/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.c
* Author             : WCH
* Version            : V1.0
* Date               : 2018/12/15
* Description        : ԶUSB豸CH372豸ṩ80ͨ(ϴ+´)ʵ´Ȼȡϴ
*******************************************************************************/
#include "CH57x_common.h"
#include "usr_cfg.h"
#include "HID.h"
#include "HostUSB_MK.h"
/******** ûԶ˵RAM ****************************************/
__align(4) UINT8  RxBuffer[ MAX_PACKET_SIZE ] ;      // IN, must even address
__align(4) UINT8  TxBuffer[ MAX_PACKET_SIZE ] ;      // OUT, must even address
extern MOUSE Mouse;
void DebugUart1Init(void)
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
    #if  DEBUG
    printf("**zpf_dbg*%s*%s**\r\n", __DATE__, __TIME__);
    printf("[PA9-TX PA8-RX] UART1 FOR DBG\r\n");
    #endif
}
//
int main(void)
{
    int i = 0;
    UINT16 loc;
    UINT16 reportLen;
    UINT8 s;
    SetSysClock(CLK_SOURCE_HSE_32MHz);
    PWR_UnitModCfg(ENABLE, UNIT_SYS_PLL);   // PLL
    DelayMs(5);
    DebugUart1Init();  //1,ڵ
    PRINT("Start @ChipID=%02X\n", R8_CHIP_ID);
    memset(&Mouse, 0, sizeof(Mouse));
    pHOST_RX_RAM_Addr = RxBuffer;
    pHOST_TX_RAM_Addr = TxBuffer;
    USB_HostInit();
    #if (defined	FOR_ROOT_UDISK_ONLY && defined DISK_BASE_BUF_LEN)
    PRINT("[ERROR] close FOR_ROOT_UDISK_ONLY and DISK_BASE_BUF_LEN\r\n");
    #endif
    PRINT("usb host init success\r\nWait Device In\r\n");
    while (1) {
        s = ERR_SUCCESS;
        if (R8_USB_INT_FG & RB_UIF_DETECT) {    // USBж
            R8_USB_INT_FG = RB_UIF_DETECT ;
            s = AnalyzeRootHub();
            if (s == ERR_USB_CONNECT)   { FoundNewDev = 1;}
        }
        if (FoundNewDev || s == ERR_USB_CONNECT) {    // µUSB豸
            FoundNewDev = 0;
            mDelaymS(200);    // USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
            s = UsrInitRootDevice(0);  // ʼUSB豸
            //if ( s != ERR_SUCCESS )   return( s );
            if (s != ERR_SUCCESS) { printf("InitRootDevice err = %02X\n", s); }
        }
        loc = SearchTypeDevice( DEV_TYPE_KEYBOARD );  // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
        loc = SearchTypeDevice(DEV_TYPE_MOUSE);    // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
    }
}

