/* 2014.09.09
*****************************************
**   Copyright  (C)  W.ch  1999-2019   **
**   Web:      http://wch.cn           **
*****************************************
**  USB-flash File Interface for CH579 **
**  KEIL423, ARM Compiler 4.1          **
*****************************************
*/
/* CH579 Uļϵͳӿ, ֧: FAT12/FAT16/FAT32 */

//#define DISK_BASE_BUF_LEN		512	/* ĬϵĴݻСΪ512ֽ(ѡΪ20484096֧ĳЩU),Ϊ0ֹڱļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹڱļж建,ӦóڵCH579LibInit֮ǰõĻʼַpDISK_BASE_BUF */

//#define NO_DEFAULT_ACCESS_SECTOR	1		/* ֹĬϵĴдӳ,бдĳ */
//#define NO_DEFAULT_DISK_CONNECT		1		/* ֹĬϵļӳ,бдĳ */
//#define NO_DEFAULT_FILE_ENUMER		1		/* ֹĬϵļöٻص,бдĳ */

#include "CH57x_common.h"
#include "CH579UFI.H"

CMD_PARAM_I	mCmdParam;						/*  */
#if		DISK_BASE_BUF_LEN > 0
//UINT8	DISK_BASE_BUF[ DISK_BASE_BUF_LEN ] __attribute__((at(BA_RAM+SZ_RAM/2)));	/* ⲿRAMĴݻ,Ϊһĳ */
UINT8	DISK_BASE_BUF[ DISK_BASE_BUF_LEN ] __attribute__((aligned (4)));	/* ⲿRAMĴݻ,Ϊһĳ */
//UINT8	DISK_FAT_BUF[ DISK_BASE_BUF_LEN ] __attribute__((aligned (4)));	/* ⲿRAMĴFATݻ,Ϊһĳ */
#endif

/* ³ԸҪ޸ */

#ifndef	NO_DEFAULT_ACCESS_SECTOR		/* ӦóжNO_DEFAULT_ACCESS_SECTORԽֹĬϵĴдӳ,Ȼбдĳ */
//if ( use_external_interface ) {  // 滻Uײдӳ
//    CH579vSectorSize=512;  // ʵʵС,512ı,ֵǴ̵С
//    CH579vSectorSizeB=9;   // ʵʵСλ,512Ӧ9,1024Ӧ10,2048Ӧ11
//    CH579DiskStatus=DISK_MOUNTED;  // ǿƿ豸ӳɹ(ֻļϵͳ)
//}

UINT8	CH579ReadSector( UINT8 SectCount, PUINT8 DataBuf )  /* Ӵ̶ȡݵ */
{
	UINT8	retry;
//	if ( use_external_interface ) return( extReadSector( CH579vLbaCurrent, SectCount, DataBuf ) );  /* ⲿӿ */
	for( retry = 0; retry < 3; retry ++ ) {  /*  */
		pCBW -> mCBW_DataLen = (UINT32)SectCount << CH579vSectorSizeB;  /* ݴ䳤 */
		pCBW -> mCBW_Flag = 0x80;
		pCBW -> mCBW_LUN = CH579vCurrentLun;
		pCBW -> mCBW_CB_Len = 10;
		pCBW -> mCBW_CB_Buf[ 0 ] = SPC_CMD_READ10;
		pCBW -> mCBW_CB_Buf[ 1 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 2 ] = (UINT8)( CH579vLbaCurrent >> 24 );
		pCBW -> mCBW_CB_Buf[ 3 ] = (UINT8)( CH579vLbaCurrent >> 16 );
		pCBW -> mCBW_CB_Buf[ 4 ] = (UINT8)( CH579vLbaCurrent >> 8 );
		pCBW -> mCBW_CB_Buf[ 5 ] = (UINT8)( CH579vLbaCurrent );
		pCBW -> mCBW_CB_Buf[ 6 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 7 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 8 ] = SectCount;
		pCBW -> mCBW_CB_Buf[ 9 ] = 0x00;
		CH579BulkOnlyCmd( DataBuf );  /* ִлBulkOnlyЭ */
		if ( CH579IntStatus == ERR_SUCCESS ) {
			return( ERR_SUCCESS );
		}
		CH579IntStatus = CH579AnalyzeError( retry );
		if ( CH579IntStatus != ERR_SUCCESS ) {
			return( CH579IntStatus );
		}
	}
	return( CH579IntStatus = ERR_USB_DISK_ERR );  /* ̲ */
}

#ifdef	EN_DISK_WRITE
UINT8	CH579WriteSector( UINT8 SectCount, PUINT8 DataBuf )  /* еĶݿд */
{
	UINT8	retry;
//	if ( use_external_interface ) return( extWriteSector( CH579vLbaCurrent, SectCount, DataBuf ) );  /* ⲿӿ */
	for( retry = 0; retry < 3; retry ++ ) {  /*  */
		pCBW -> mCBW_DataLen = (UINT32)SectCount << CH579vSectorSizeB;  /* ݴ䳤 */
		pCBW -> mCBW_Flag = 0x00;
		pCBW -> mCBW_LUN = CH579vCurrentLun;
		pCBW -> mCBW_CB_Len = 10;
		pCBW -> mCBW_CB_Buf[ 0 ] = SPC_CMD_WRITE10;
		pCBW -> mCBW_CB_Buf[ 1 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 2 ] = (UINT8)( CH579vLbaCurrent >> 24 );
		pCBW -> mCBW_CB_Buf[ 3 ] = (UINT8)( CH579vLbaCurrent >> 16 );
		pCBW -> mCBW_CB_Buf[ 4 ] = (UINT8)( CH579vLbaCurrent >> 8 );
		pCBW -> mCBW_CB_Buf[ 5 ] = (UINT8)( CH579vLbaCurrent );
		pCBW -> mCBW_CB_Buf[ 6 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 7 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 8 ] = SectCount;
		pCBW -> mCBW_CB_Buf[ 9 ] = 0x00;
		CH579BulkOnlyCmd( DataBuf );  /* ִлBulkOnlyЭ */
		if ( CH579IntStatus == ERR_SUCCESS ) {
			mDelayuS( 200 );  /* дʱ */
			return( ERR_SUCCESS );
		}
		CH579IntStatus = CH579AnalyzeError( retry );
		if ( CH579IntStatus != ERR_SUCCESS ) {
			return( CH579IntStatus );
		}
	}
	return( CH579IntStatus = ERR_USB_DISK_ERR );  /* ̲ */
}
#endif
#endif  // NO_DEFAULT_ACCESS_SECTOR

#ifndef	NO_DEFAULT_DISK_CONNECT			/* ӦóжNO_DEFAULT_DISK_CONNECTԽֹĬϵļӳ,Ȼбдĳ */
// only one host port
#define	UHUB0_CTRL		R8_UHOST_CTRL
#define	UHUB1_CTRL		R8_UHOST_CTRL
#define	bUHS_H0_ATTACH	RB_UMS_DEV_ATTACH
#define	bUHS_H1_ATTACH	RB_UMS_DEV_ATTACH
/* Ƿ */
UINT8	CH579DiskConnect( void )
{
	R8_USB_DEV_AD &= 0x7F;
	if ( R8_USB_DEV_AD == USB_DEVICE_ADDR || R8_USB_DEV_AD == USB_DEVICE_ADDR + 1 ) {  /* Root-HUBµUSB豸 */
		if ( ( R8_USB_DEV_AD == USB_DEVICE_ADDR ? UHUB0_CTRL : UHUB1_CTRL ) & RB_UH_PORT_EN ) {  /* Root-HUBµUSB豸δ */
			return( ERR_SUCCESS );  /* USB豸Ѿδ */
		}
		else if ( R8_USB_MIS_ST & (UINT8)( R8_USB_DEV_AD == USB_DEVICE_ADDR ? bUHS_H0_ATTACH : bUHS_H1_ATTACH ) ) {  /* Root-HUBµUSB豸 */
mDiskConnect:
			CH579DiskStatus = DISK_CONNECT;  /* Ͽ */
			return( ERR_SUCCESS );  /* ⲿHUBUSB豸Ѿӻ߶Ͽ */
		}
		else {  /* USB豸Ͽ */
mDiskDisconn:
			CH579DiskStatus = DISK_DISCONNECT;
			return( ERR_USB_DISCON );
		}
	}
#ifndef	FOR_ROOT_UDISK_ONLY
	else if ( R8_USB_DEV_AD > 0x10 && R8_USB_DEV_AD <= 0x14 || R8_USB_DEV_AD > 0x20 && R8_USB_DEV_AD <= 0x24 ) {  /* ⲿHUBĶ˿µUSB豸 */
		if ( ( R8_USB_DEV_AD & 0x20 ? UHUB1_CTRL : UHUB0_CTRL ) & RB_UH_PORT_EN ) {  /* Root-HUBµⲿHUBδ */
			TxBuffer[ MAX_PACKET_SIZE - 1 ] = R8_USB_DEV_AD;  /*  */
			R8_USB_DEV_AD = USB_DEVICE_ADDR - 1 + ( R8_USB_DEV_AD >> 4 );  /* USB˵USBַָHUB */
			CH579IntStatus = HubGetPortStatus( TxBuffer[ MAX_PACKET_SIZE - 1 ] & 0x0F );  /* ѯHUB˿״̬,TxBuffer */
			if ( CH579IntStatus == ERR_SUCCESS ) {
				if ( TxBuffer[2] & (1<<(HUB_C_PORT_CONNECTION-0x10)) ) {  /* ⵽HUB˿ϵĲ¼ */
					CH579DiskStatus = DISK_DISCONNECT;  /* ٶΪHUB˿ϵUSB豸Ͽ */
					HubClearPortFeature( TxBuffer[ MAX_PACKET_SIZE - 1 ] & 0x0F, HUB_C_PORT_CONNECTION );  /* HUB˿¼״̬ */
				}
				R8_USB_DEV_AD = TxBuffer[ MAX_PACKET_SIZE - 1 ];  /* USB˵USBַָUSB豸 */
				if ( TxBuffer[0] & (1<<HUB_PORT_CONNECTION) ) {  /* ״̬ */
					if ( CH579DiskStatus < DISK_CONNECT ) {
						CH579DiskStatus = DISK_CONNECT;  /* Ͽ */
					}
					return( ERR_SUCCESS );  /* USB豸Ѿӻ߶Ͽ */
				}
				else {
//					CH579DiskStatus = DISK_DISCONNECT;
//					return( ERR_USB_DISCON );
					CH579DiskStatus = DISK_CONNECT;
					return( ERR_HUB_PORT_FREE );  /* HUBѾӵHUB˿δӴ */
				}
			}
			else {
				R8_USB_DEV_AD = TxBuffer[ MAX_PACKET_SIZE - 1 ];  /* USB˵USBַָUSB豸 */
				if ( CH579IntStatus == ERR_USB_DISCON ) {
//					CH579DiskStatus = DISK_DISCONNECT;
//					return( ERR_USB_DISCON );
					goto mDiskDisconn;
				}
				else {
					CH579DiskStatus = DISK_CONNECT;  /* HUBʧ */
					return( CH579IntStatus );
				}
			}
		}
		else if ( R8_USB_MIS_ST & (UINT8)( R8_USB_DEV_AD & 0x20 ? bUHS_H1_ATTACH : bUHS_H0_ATTACH ) ) {  /* Root-HUBµUSB豸,ⲿHUBUSB豸Ѿӻ߶Ͽ */
//			CH579DiskStatus = DISK_CONNECT;  /* Ͽ */
//			return( ERR_SUCCESS );  /* ⲿHUBUSB豸Ѿӻ߶Ͽ */
			goto mDiskConnect;
		}
		else {  /* ⲿHUBϿ */
			CH579DiskStatus = DISK_DISCONNECT;
		}
	}
#endif
	else {
//		CH579DiskStatus = DISK_DISCONNECT;
//		return( ERR_USB_DISCON );
		goto mDiskDisconn;
	}
}
#endif  // NO_DEFAULT_DISK_CONNECT

#ifndef	NO_DEFAULT_FILE_ENUMER			/* ӦóжNO_DEFAULT_FILE_ENUMERԽֹĬϵļöٻص,Ȼбдĳ */
void xFileNameEnumer( void )			/* ļöٻصӳ */
{
/* ָöCH579vFileSizeΪ0xFFFFFFFFFileOpenôÿһļFileOpenñص
   صxFileNameEnumerغFileOpenݼCH579vFileSizeöֱļĿ¼ǣ
   ڵFileOpen֮ǰһȫֱΪ0FileOpenص󣬱CH579vFdtOffsetõṹFAT_DIR_INFO
   ṹеDIR_AttrԼDIR_NameжǷΪļĿ¼¼Ϣȫֱ
   FileOpenغжϷֵERR_MISS_FILEERR_FOUND_NAMEΪɹȫֱΪЧļ
   ڱصxFileNameEnumerнCH579vFileSizeΪ1ô֪ͨFileOpenǰǻص */
#if		0
	UINT8			i;
	UINT16			FileCount;
	PX_FAT_DIR_INFO	pFileDir;
	PUINT8			NameBuf;
	pFileDir = (PX_FAT_DIR_INFO)( pDISK_BASE_BUF + CH579vFdtOffset );  /* ǰFDTʼַ */
	FileCount = (UINT16)( 0xFFFFFFFF - CH579vFileSize );  /* ǰļö,CH579vFileSizeֵ0xFFFFFFFF,ҵļݼ */
	if ( FileCount < sizeof( FILE_DATA_BUF ) / 12 ) {  /* 黺Ƿ㹻,ٶÿļռ12ֽڴ */
		NameBuf = & FILE_DATA_BUF[ FileCount * 12 ];  /* 㱣浱ǰļĻַ */
		for ( i = 0; i < 11; i ++ ) NameBuf[ i ] = pFileDir -> DIR_Name[ i ];  /* ļ,Ϊ11ַ,δո */
//		if ( pFileDir -> DIR_Attr & ATTR_DIRECTORY ) NameBuf[ i ] = 1;  /* жĿ¼ */
		NameBuf[ i ] = 0;  /* ļ */
	}
#endif
}
#endif  // NO_DEFAULT_FILE_ENUMER

UINT8	CH579LibInit( void )  /* ʼCH579,ɹ0 */
{
	if ( CH579GetVer( ) < CH579_LIB_VER ) return( 0xFF );  /* ȡǰӳİ汾,汾̫򷵻ش */
#if		DISK_BASE_BUF_LEN > 0
	pDISK_BASE_BUF = & DISK_BASE_BUF[0];  /* ָⲿRAMĴݻ */
	pDISK_FAT_BUF = & DISK_BASE_BUF[0];  /* ָⲿRAMĴFATݻ,pDISK_BASE_BUFԽԼRAM */
//	pDISK_FAT_BUF = & DISK_FAT_BUF[0];  /* ָⲿRAMĴFATݻ,pDISK_BASE_BUFٶ */
/* ϣļȡٶ,ôеCH579LibInit֮,pDISK_FAT_BUFָһpDISK_BASE_BUFͬСĻ */
#endif
	CH579DiskStatus = DISK_UNKNOWN;  /* δ֪״̬ */
	CH579vSectorSizeB = 9;  /* Ĭϵ̵512B */
	CH579vSectorSize = 512;  // Ĭϵ̵512B,ֵǴ̵С
	CH579vStartLba = 0;  /* ĬΪԶFDDHDD */
	return( ERR_SUCCESS );
}
